/*----- demo04.cpp

	sujets :

		- ajout d'un cadre
		- ajout de cases  cocher
		- ajout d'une tiquette
		- surcharge du membre on_call()

*/

/*-----
	dfinitions
*/
#include	"xe.h"				/* gestionnaire d'vnements	*/
#include	"xk.h"				/* constantes clavier			*/
#include	"xo.h"				/* dfinitions des objets		*/
#include	"xw.h"				/* gestionnaire de fentres		*/

/*-----
	classe de fentre MyWin

	Constructeur de MyWin :

		- titre str.

	Destructeur de MyWin :

		- aucun destructeur spcifique.

	Dfinition de MyWin :

		- largeur de 60 colonnes,
		- hauteur de 13 lignes,
		- fentre standard (cadre, titre, ombre, dplaable, modale).

	membre on_call() :

		- il est dclench lorsqu'un objet est appel pour excution.

		- en paramtre, on_call() apporte l'adresse de l'objet courant
		  demandant cette excution.

	Membre on_char() :

		- il est dclench pour tout caractre non reconnu par la fentre
		  ou ses objets.

		- en paramtre, on_char() apporte le code du caractre saisi.

*/

class	MyWin : public XWin
		{
	protected :
		virtual	void	on_call (XObj *obj);
		virtual	void	on_char (int key);

	public :
		MyWin (const char *str);

		};

MyWin::MyWin (const char *str)
		: XWin(60, 13)
		{
		/* associe un titre  la fentre
		*/
		head(str);

		/* ajout du cadre
			identificateur :	1
			style :				enfonc
		*/
		link(new XBox(1, 1, 1, 28, 5, 0, 1));

		/* ajout de l'tiquette
			identificater :		2000
			raccourci clavier : ALT-C
		*/
		link(new XLabel(2000, 1, 2, "&Checks", xk_aC));

		/* ajout des cases  cocher 2001, 2002 et 2003
		*/
		link(new XCheck(2001, 2, 3, 24, "Check &1", xk_a1));
		link(new XCheck(2002, 3, 3, 24, "Check &2", xk_a2));
		link(new XCheck(2003, 4, 3, 24, "Check &3", xk_a3));

		/* ajout du bouton poussoir Ok
			identificateur :	1000
			raccourci clavier :	ALT-O
		*/
		link(new XPush(1000, 7, 45, 10, "&Ok", xk_aO));

		/* ajout du bouton poussoir Quitte
			identificateur :	1001
			raccourci clavier :	ALT-Q
		*/
		link(new XPush(1001, 9, 45, 10, "&Quitte", xk_aQ));
		}

void	MyWin::on_call (XObj *obj)
		{
		int		typ;

		/* rcupre le type de l'objet
		*/
		typ = obj->type();

		/* si excution d'un bouton poussoir
		*/
		if (typ == xo_PUSH)
			{
			/* enfonce le bouton
			*/
			xo(obj, XPush)->push(1);

			/* ferme la fentre
			*/
			hide();
			}
		/* si excution d'une case  cocher
		*/
		else if (typ == xo_CHECK)
			{
			/* inverse l'tat de la case  cocher
			*/
			xo(obj, XCheck)->revv(1);
			}
		/* si excution d'une tiquette
		*/
		else if (typ == xo_LABEL)
			{
			/* si tiquette 2000
			*/
			if (obj->id() == 2000)
				/* branche vers la premire case  cocher
				*/
				curr(2001);

			}

		}

void	MyWin::on_char (int key)
		{
		/* si caractre ESCAPE
		*/
		if (key == xk_ESC)
			/* alors ferme la fentre
			*/
			hide();

		}

/*-----
	app_init() - initialisation de l'application

	L'initialisation de l'application passe par :

		- l'initialisation globale du gestionnaire de fentres,
		- l'affichage du bureau.

*/

void	app_init (void)
		{
		/* initialise tous les gestionnaires en une seule passe
		*/
		xw.full(1);

		/* affiche le bureau
		*/
		xw.desk();
		}

/*-----
	app_quit() - terminaison de l'application

	La terminaison de l'application passe par :

		- la terminaison globale du gestionnaire de fentres.

*/

void	app_quit (void)
		{
		/* quitte tous les gestionnaires en une seule passe
		*/
		xw.full(0);
		}

/*-----
	app_exec() - excution de l'application

	L'excution de l'application passe par :

		- la cration d'une fentre de type MyWin,
		- l'ouverture de la fentre,
		- la lecture de chaque vnement,
		- l'valuation de l'vnement rcupr.

	L'excution prend fin lorsque plus aucune fentre ne reste ouverte.

*/

void	app_exec (void)
		{
		XEvn	evn;
		MyWin *	win;

		/* cre la fentre MyWin
		*/
		win = new MyWin("MA FENETRE");

		/* ouvre la fentre cre
		*/
		win->topw();

		/* boucle de lecture des vnements
		*/
		while (1)
			{
			/* lit le prochain vnement
			*/
			xe.next(evn);

			/* si aucune fentre aprs valuation de l'vnement rcupr
			*/
			if (xw.eval(evn) == 0)
				/* alors quitte la boucle
				*/
				break;

			}

		/* dtruit la fentre (dj ferme)
		*/
		delete win;
		}

void	main (void)
		{
		/* initialisation de l'application
		*/
		app_init();

		/* excution de l'application
		*/
		app_exec();

		/* fin de l'application
		*/
		app_quit();
		}
